#include <process.h>

#ifdef _DEBUG
#define DBGPRINTOUT(msg)		{Msg(msg);}
#define DBGPRINTOUT2(msg,val)	{Msg(msg,val);}
#else
#define DBGPRINTOUT(msg)		
#define DBGPRINTOUT2(msg,val)	
#endif

#include "threads2.cpp"

/*=========================================================================*/
/* for MultiCPU                                                            */
/*=========================================================================*/
void CodecInst::GetProcessorsCount()
{
	if(processors != 0) return;

	DWORD ProcessAffinityMask;
	DWORD SystemAffinityMask;
	BOOL ret = GetProcessAffinityMask( GetCurrentProcess() , &ProcessAffinityMask , &SystemAffinityMask);
	if(ret == 0 || ProcessAffinityMask == 0){
		processors = 1;
		processor_mask[0] = 0x01;
	} else {
		processors = 0;
		for(DWORD mask=1; ProcessAffinityMask != 0 ; mask = mask<< 1){
			if(ProcessAffinityMask & mask){
				processor_mask[processors] = mask;
				processors++;
			}
			ProcessAffinityMask &= (~mask);
		}
	}
	for(int i=processors; i<MAX_PROCESSOR_NUM; i++)
		processor_mask[i] = processor_mask[i%processors];
	return;
}

DWORD CodecInst::CompressMulti(ICCOMPRESS* icinfo, DWORD dwSize) {
	//Msg("[Com]IN:w=%d,h=%d OUT:w=%d,h=%d\n", icinfo->lpbiInput->biWidth, icinfo->lpbiInput->biHeight, icinfo->lpbiOutput->biWidth, icinfo->lpbiOutput->biHeight);
	//Msg("multi_mode=%s\n", (multi_mode ? "true" : "false"));
	//Msg("processors=%d, forced_processors=%d\n", processors, forced_processors);
	if(multi_mode)
		return Compress3(icinfo,dwSize);
	return Compress(icinfo,dwSize);
}

DWORD CodecInst::DecompressMulti(ICDECOMPRESS* icinfo, DWORD dwSize) {
	//Msg("[Dec]IN:w=%d,h=%d OUT:w=%d,h=%d\n", icinfo->lpbiInput->biWidth, icinfo->lpbiInput->biHeight, icinfo->lpbiOutput->biWidth, icinfo->lpbiOutput->biHeight);
	bool decmulti = false;
	CompressInfoHeader* header = (CompressInfoHeader*)((unsigned char*)(icinfo->lpInput) + (icinfo->lpbiInput->biSizeImage) - sizeof(CompressInfoHeader));
	if((header->id == 0) && (header->unitnum <= MAX_PROCESSOR_NUM) && (header->offset < icinfo->lpbiInput->biSizeImage)){
		CompressInfo* info = (CompressInfo*)((unsigned char*)(icinfo->lpInput) + (header->offset));
		if(info->code_start == 0){
			decmulti = true;
		}
	}
	//Msg("decmulti=%s\n", (decmulti ? "true" : "false"));
	if(decmulti)
		return Decompress3(icinfo, dwSize);
	else 
		return Decompress(icinfo, dwSize);
}
